const {ipcRenderer} = require('electron')
const {createObjectURL} = require('blob-util')
const $ = require('jquery')
const {makeEquipmentPDF} = require('../utilities/reportgen')
let windowlist = []
let previframe = []

const {createAlert} = require("../utilities/alert_box")

document.getElementById("quit_app").addEventListener("click", ()=>{
  ipcRenderer.invoke('quit_app')
});

mode_list=["DENIED","NEW FORM","APPROVED FORM","COMPLETED"]

// CLOSE ALL POPUPS ON PAGE CHANGE
window.onbeforeunload = function(){
  windowlist.forEach(win=>{
    win.close()
  })
  windowlist = []
  viewerEle.innerHTML = '';
};

// dynamic html stuff:
let values = window.location.search.split('?')
console.log('vals', values)
let stagenum = 0

if (values.length >= 1 && values[1] && parseInt(values[1])){
  stagenum = parseInt(values[1])
}
console.log("stagenum",stagenum)

Modify_Type='und'
// Major Button Logic
let goto_add = document.getElementById("goto_add")
goto_add.addEventListener('click', () => {
    swapPage('Add', goto_add, 'forestgreen')

    $('#goto_back').show()
    
    $(formno).hide()
    $(avlserial).hide()
    $(Movedepartment).hide()
    $(Movelocation).hide()
    $(femac).hide()
    $(femar).hide()
    $(otherInput).show()
    $(othervendorInput).show()
    $(approvedenyrequest).hide()
    Modify_Type= 'ADD'
    document.getElementById("equipmentvendors").setAttribute("required","required")
    // document.getElementById("purchasedate").setAttribute("required","required")
    $('#Add').find('*').prop('disabled', false)
    $('#addsubmit').show()
    $('#goto_selection').hide()
    $(lognotelist).hide()
    $(lognotelistheader).hide()
    uploadfilelist=[]




    ResetAll()

})
let goto_delete = document.getElementById("goto_delete")
goto_delete.addEventListener('click', () => {
    swapPage('Lookupequipmentid', goto_delete, 'navy')
    $(goto_back).show()
    $(formno).hide()
    $(femac).hide()
    $(femar).hide()
    $(avlserial).hide()
    $(Movedepartment).hide()
    $(Movelocation).hide()
    $(approvedenyrequest).hide()
    $(lognotelist).hide()
    $(lognotelistheader).hide()
    Modify_Type= 'DEL'
    document.getElementById("equipmentvendors").removeAttribute("required")
    // document.getElementById("purchasedate").removeAttribute("required")
    $('#Add').find('*').prop('disabled', true)
    $('#notes').prop('disabled', false)
    $('#addsubmit').prop('disabled', false)
    $('#documentlist').prop('disabled', false)
    $('#upload_documentation_button').prop('disabled', false)
    $("addsubmit").show()
    uploadfilelist=[]
  
    ResetAll()

})
let goto_transfer = document.getElementById("goto_transfer")
goto_transfer.addEventListener('click', () => {
    swapPage('Lookupequipmentid', goto_transfer, 'darkred')
    $(goto_back).show()
    $(formno).hide()
    //$(avlserial).hide()
    $(Movedepartment).show()
    $(Movelocation).show()
    $(femac).hide()
    $(femar).hide()
    $(approvedenyrequest).hide()
    Modify_Type= 'TRA'
    document.getElementById("equipmentvendors").removeAttribute("required")
    // document.getElementById("purchasedate").removeAttribute("required")
    $('#Add').find('*').prop('disabled', true)
    $('#notes').prop('disabled', false)
    $('#addsubmit').prop('disabled', false)
    $('#documentlist').prop('disabled', false)
    $('#upload_documentation_button').prop('disabled', false)
    $('#newdepartment').prop('disabled', false)
    $('#newlocation').prop('disabled', false)
    $("option").prop("disabled", false)//doubt
    $("addsubmit").show()
    $(lognotelistheader).hide()
    $(lognotelist).hide()
    uploadfilelist=[]
    
    ResetAll()
})


const selection = {}
const subitemselection = {}
function makeRecaplistSelectable(){
  let trs = document.querySelectorAll("tr");
  for(let i = 0; i < trs.length; i++){
    // console.log('table row class:', trs[i].className)
    if (trs[i].className.includes('singleselect')){
      trs[i].addEventListener("mouseup", function(){
        // console.log('selection set')
        for(let i = 0; i < trs.length; i++){
          let cn = trs[i].className, thc = " selected", start_idx = cn.indexOf(thc);
          if(start_idx != -1 && trs[i].className.includes('singleselect')) {
            cn = cn.replace(thc,"");
            trs[i].className = cn;
          }
        }
        let cn = this.className, thc = " selected", start_idx = cn.indexOf(thc);
        if(start_idx == -1) cn += thc;
        this.className = cn;
        selection.value = JSON.parse(this.cells[0].textContent).Equipmentformid

        console.log('selection set', selection.value)
        // getExtraUserData(JSON.parse(this.cells[0].textContent))
      })
    }
  }
}


const table = document.getElementById('recaplist')
let goto_list = document.getElementById("goto_list")
goto_list.addEventListener('click', () => {
  ResetAll()
 

  if (stagenum == 0){
    
    $('#goto_back').hide()
    $(open_selected).hide()
    $(goto_add).hide()
    $(goto_delete).hide()
    $(goto_transfer).hide()
    $(addsubmit).hide()
    $(pdf_selected).hide()
    
    
    document.getElementById("denyrequest").textContent = "Cancel"
    document.getElementById("approverequest").textContent = "Resubmit"
    $(goto_selection).show()
    document.getElementById("goto_list").textContent = "Denied Requests"
    document.getElementById("goto_selection").textContent = "Selected Denied Request"
    document.getElementById("femar").style.display="none"
    document.getElementById("femac").style.display="none"



  } else if(stagenum ==1){
    $(goto_back).hide()
    $(addsubmit).hide()
    $(goto_add).hide()
    $(goto_delete).hide()
    $(goto_transfer).hide()
    $(modifyselected).hide()
    $(createnew).hide()
    $('#Add').find('*').prop('disabled', true)
    $('#notes').prop('disabled', false)
    $('#addsubmit').prop('disabled', false)
    // $('#newdepartment').prop('disabled', true)
    // $('#newlocation').prop('disabled', true)
    $("option").prop("disabled", false)//doubt
    $('#approverequest').prop('disabled', false)
    $('#denyrequest').prop('disabled', false)
    $(avlserial).hide()
    
    // $('input').prop('disabled', true)
    // $('option').prop('disabled', true)
    // $('select').prop('disabled', true)
    $('#notes').prop('disabled', false)
    $('#femacode').prop('disabled', false)
    $('#femarate').prop('disabled', false)
    $('#upload_documentation_button').prop('disabled', true)
    $('#documentlist').prop('disabled', false)
    //$('#upload_documentation_button').prop('disabled', false)
  }else{
    document.getElementById("approverequest").textContent = "Entered in Cartegraph"
    $('#femacode').prop('disabled', true)
    $('#femarate').prop('disabled', true)
    $(goto_back).hide()
    $(addsubmit).hide()
    $(goto_add).hide()
    $(goto_delete).hide()
    $(goto_transfer).hide()
    $(modifyselected).hide()
    $(createnew).hide()
    $('#Add').find('*').prop('disabled', true)
    $('#notes').prop('disabled', false)
    $('#addsubmit').prop('disabled', false)
    // $('#newdepartment').prop('disabled', true)
    // $('#newlocation').prop('disabled', true)
    $("option").prop("disabled", false)//doubt
    $('#approverequest').prop('disabled', false)
    $('#denyrequest').prop('disabled', false)
    $('#approvedenyrequest').prop('disabled', false)
    $(avlserial).hide()
    // $('input').prop('disabled', true)
    // $('option').prop('disabled', true)
  // $('select').prop('disabled', true)
    $('#notes').prop('disabled', false)
    $('#femacode').prop('disabled', false)
    $('#femarate').prop('disabled', false)
    $('#upload_documentation_button').prop('disabled', true)
    $('#documentlist').prop('disabled', false)
     //$('#upload_documentation_button').prop('disabled', false)
    
  }

  swapPage('List', goto_list, 'navy')

  requestList()
})
function requestList(){

  arg = {
    target_name: 'Status',
    target_val: mode_list[stagenum]
  }
  


  selection.value = null
  let trs = document.getElementsByClassName('singleselect')
  for(let i = trs.length-1; i >= 0; i--){
    trs[i].remove()
  }




  ipcRenderer.invoke('loadequipmentlist',arg).then(result => {
    console.log ("result",result)
    arg = result.recordset.reverse()
    console.log("arg",result.recordset.reverse())
    

    for (const entry of arg) {
      let row = table.insertRow()
      row.className = 'singleselect'
      hiddencell = row.insertCell(0)
      hiddencell.textContent = JSON.stringify(entry)
      $(hiddencell).hide()
      row.insertCell(1).textContent = entry.Modify_Type + "00" +entry.Formid
      row.insertCell(2).textContent = entry.Data_NO
      row.insertCell(3).textContent = new Date(entry.Submit_Date).toUTCString().substring(4,16)
      row.insertCell(4).textContent = entry.Department
      row.insertCell(5).textContent = entry.emp_fname + " "+ entry.emp_lname
      row.insertCell(6).textContent = entry.Status
    }
    makeRecaplistSelectable()
  })

}

let goto_selection = document.getElementById("goto_selection")
goto_selection.addEventListener('click', () => {
  swapPage('Add', goto_selection, 'darkred')
  $(goto_back).show()
  

})

let open_selected = document.getElementById("open_selected")
open_selected.addEventListener('click', async() => {
  $(goto_back).show()
  event.preventDefault()
  let target = selection.value
  if (!target || target == '') {
    createAlert('no selection to load')
  } else {
    console.log("loading", target)
    arg = await requestEntry(target)
    console.log('arg', arg)
    viewTravelReport(2, target, arg)
    swapPage('Add', goto_selection, 'darkred')
  }
})

async function loadDocumentsByIdList(filesys_id_list) {
  // reset list

 
  for (let i = documentlist.length - 1; i >= 0; i--){
    documentlist.remove(i);
  }


  for (let i = documentlist_mirror.length - 1; i >= 0; i--){
    documentlist_mirror.remove(i);
  }
  
  console.log('filesys', filesys_id_list)
  

  filesysarg = {
    filesys_id_list:filesys_id_list
  }
  console.log('files',filesysarg)

  await ipcRenderer.invoke('load-file-list-filesys', filesysarg).then(results =>{
    file_list = results.recordset
    console.log('files', file_list)
    file_list.forEach(file_details =>{
      let id = file_details.filesys_id

      console.log('file id', id)
      document.getElementById('documentation_type').value = ''

      let name = file_details.filesys_name +' ' +new Date(file_details.filesys_time).toUTCString().substring(5, 16)

      option = document.createElement('option')
      option.value = id
      option.text = name
      documentlist.prepend(option)

      option = document.createElement('option')
      option.value = id
      option.text = name
      documentlist_mirror.prepend(option)
    })
  }).catch(err =>{
    console.log('no files found', err.name)
  })
}

function swapPage(pageName, elmnt, color){

    const tabcontent = document.getElementsByClassName("tabcontent")
    for (i=0; i < tabcontent.length; i++) {
    $(tabcontent[i]).hide()
    }

    const tablinks = document.getElementsByClassName("tablink")
    for (i=0; i < tablinks.length; i++) {
    tablinks[i].style.backgroundColor = ""
    tablinks[i].style.backgroundImage = ""
    }

    let targetpage = document.getElementById(pageName)
    $(targetpage).show()
    targetpage.style.backgroundColor = color
    elmnt.style.backgroundColor = color;
    elmnt.style.backgroundImage = 'none'
}



//   equipmenttype = ipcRenderer.invoke('getequipmenttype').then(result => {
//     equipmenttype = result
//     console.log("equipmenttype",equipmenttype)
//     for (let i = 0; i < equipmenttype.length; i++) {
//       let name = equipmenttype[i].EquipmentClass
//       let id = equipmenttype[i].EquipmentClass
//       option = document.createElement('option')
//       option.value = id
//       option.text = name
//       document.getElementById("equipmenttype").add(option)
//     }
//   })

equipmentlocations = ipcRenderer.invoke('getequipmentlocations').then(result => {
  equipmentlocations = result
  console.log("equipmentlocations",equipmentlocations)
  for (let i = 0; i < equipmentlocations.length; i++) {
    let name = equipmentlocations[i].LocationID
    let id = equipmentlocations[i].LocationID
    option = document.createElement('option')
    option.value = id
    option.text = name
    document.getElementById("equipmentlocations").add(option)
    option = document.createElement('option')
    option.value = id
    option.text = name
    document.getElementById("newlocation").add(option)
  }
})

departments= ipcRenderer.invoke('getdepartments').then(result => {
  departments = result
  console.log("departments",departments)
  for (let i = 0; i < departments.length; i++) {
    let name = departments[i].Department
    let id = departments[i].Department
    option = document.createElement('option')
    option.value = id
    option.text = name
    document.getElementById("departments").add(option)
    option = document.createElement('option')
    option.value = id
    option.text = name
    document.getElementById("newdepartment").add(option)
  }
})

equipmentclassifications= ipcRenderer.invoke('getequipmentclassifications').then(result => {
  equipmentclassifications = result
  console.log("equipmentclassifications",equipmentclassifications)
  for (let i = 0; i < equipmentclassifications.length; i++) {
    let name = equipmentclassifications[i].Classification
    let id = equipmentclassifications[i].Classification
    option = document.createElement('option')
    option.value = id
    option.text = name
    document.getElementById("equipmentclassifications").add(option)
  }
})

//   const manulist = document.getElementById("equipmentmanufacturers")

equipmentmanufacturers= ipcRenderer.invoke('getequipmentmanufacturers').then(result => {
  equipmentmanufacturers = result
  console.log("equipmentmanufacturers",equipmentmanufacturers)
  for (let i = 0; i < equipmentmanufacturers.length; i++) {
    let name = equipmentmanufacturers[i].Manufacturer
    let id = equipmentmanufacturers[i].Manufacturer
    option = document.createElement('option')
    option.value = id
    option.text = name
  //   manulist.appendChild(option)
    document.getElementById("equipmentmanufacturers").add(option)
  }
  // document.getElementById("equipmentmanufacturersnew").setAttribute('list', "equipmentmanufacturers")
})

equipmentvendors= ipcRenderer.invoke('getequipmentvendors').then(result => {
  equipmentvendors = result
  console.log("equipmentvendors",equipmentvendors)
  for (let i = 0; i < equipmentvendors.length; i++) {
    let name = equipmentvendors[i].ID
    let id = equipmentvendors[i].ID
    option = document.createElement('option')
    option.value = id
    option.text = name
    document.getElementById("equipmentvendors").add(option)
  }
})

var otherInput = document.getElementById("otherInput");
var serviceTypeInput2 = document.getElementById("equipmentmanufacturers");
serviceTypeInput2.addEventListener('change', function() {
  if (serviceTypeInput2.value == "Other") {
    $(otherInput).show();
    otherInput.setAttribute("required","required")
  } else {
    otherInput.removeAttribute("required")
    $(otherInput).hide()
  }
});

var othervendorInput = document.getElementById("othervendorInput");
var serviceTypeInput = document.getElementById("equipmentvendors");
serviceTypeInput.addEventListener('change', function() {
  if (serviceTypeInput.value == "Other") {
    // FIXME: FIXED: fixed typo: was othervendorinput, not othervendorInput
    $(othervendorInput).show();
    othervendorInput.setAttribute("required","required")
  } else {
    othervendorInput.removeAttribute("required")
    $(othervendorInput).hide()
  }
});


const os = require ('os');
const submitted_by = os.userInfo ().username;
document.getElementById("addsubmit").addEventListener("click",async () =>{
  event.preventDefault()
  
  console.log('username',submitted_by)
 
 
  if(notes.value ==""){
    createAlert("Info","Please enter Notes")
  }else{
    equipmentmanufacturers=document.getElementById("equipmentmanufacturers").value

  if (equipmentmanufacturers=="Other"){
    equipmentmanufacturers=document.getElementById("otherInput").value
  }

  equipmentvendors=document.getElementById("equipmentvendors").value
  if (equipmentvendors=="Other"){
    equipmentvendors=document.getElementById("othervendorInput").value
  }

  arg = {
    datanumber:document.getElementById("datanumber").value,
    equipmentclassifications:document.getElementById("equipmentclassifications").value,
    purchasedate:document.getElementById("purchasedate").value,
    equipmentmanufacturers:equipmentmanufacturers,
    model:document.getElementById("model").value,
    year:document.getElementById("year").value,
    inservicedate:document.getElementById("inservicedate").valueAsDate,
    purchasedate:document.getElementById("purchasedate").valueAsDate,
    serialnumber:document.getElementById("serialnumber").value,
    attachedequipid:document.getElementById("attachedequipid").value,
    equipmentvendors:equipmentvendors,
    equipmentlocations:document.getElementById("equipmentlocations").value,
    avlserialnumber:document.getElementById("avlserialnumber").value,
    departments:document.getElementById("departments").value,
    newlocation:document.getElementById("newlocation").value,
    newdepartment:document.getElementById("newdepartment").value,
    notes:document.getElementById("notes").value,
    Modify_Type: Modify_Type,
    submitted_by: submitted_by,
    
    Linked_File:JSON.stringify(uploadfilelist)
    
  }
 
  ipcRenderer.invoke('submitaddequipmentform', arg)
  .then (event => {
    createAlert("success","Submitted Sucessfully")
    if(Modify_Type="ADD"){
      goto_add.click()
    }else if(Modify_Type="DEL"){
      goto_delete.click()
    }else{
      goto_transfer.click()
    }
  


    // document.getElementById("goto-home").click()
  }).catch(error => {
    console.log("submiterror",error)
    createAlert("error","Failed to submit")
  })

  }
  
 



})




function ResetAll(){
  document.getElementById("datanumber").value=""
  document.getElementById("datanumber2").value=""
  document.getElementById("equipmentclassifications").value=""
  document.getElementById("purchasedate").value=""
  document.getElementById("equipmentmanufacturers").value=""
  document.getElementById("equipmentvendors").value=""
  document.getElementById("otherInput").value=""
  document.getElementById("othervendorInput").value=""
  document.getElementById("model").value=""
  document.getElementById("year").value=""
  document.getElementById("inservicedate").value=""
  document.getElementById("purchasedate").value=""
  document.getElementById("serialnumber").value=""
  document.getElementById("attachedequipid").value=""
  document.getElementById("equipmentlocations").value=""
  document.getElementById("departments").value=""
  document.getElementById("newlocation").value=""
  document.getElementById("newdepartment").value=""
  document.getElementById("femacode").value=""
  document.getElementById("femarate").value=""
  document.getElementById("notes").value=""
  
  for (let i = lognotelist.length - 1; i >= 0; i--){
    lognotelist.remove(i);
  }

  documentlist = document.getElementById('documentlist')
  documentlist_mirror = document.getElementById('documentlist_mirror')

  // reset list
  for (let i = documentlist.length - 1; i >= 0; i--){
    documentlist.remove(i);
  }

  for (let i = documentlist_mirror.length - 1; i >= 0; i--){
    documentlist_mirror.remove(i);
  }

  

  othervendorInput.removeAttribute("required")
  $(othervendorInput).hide()

  otherInput.removeAttribute("required")
  $(otherInput).hide()
}

function base64ToUint8Array(base64) {
  var raw = atob(base64);
  var uint8Array = new Uint8Array(raw.length);
  for (var i = 0; i < raw.length; i++) {
    uint8Array[i] = raw.charCodeAt(i);
  }
  return uint8Array;
}

const viewerEle = document.getElementById('viewer');

let startx = 0
let starty = 0
document.getElementById('receiptModal').addEventListener('dragstart', event=>{
  console.log('receipt dragged!', event)
  startx = event.offsetX
  starty = event.offsetY
})
document.getElementById('receiptModal').addEventListener('dragend', event=>{
  console.log('receipt dragged!', event)
  if ((startx - event.offsetX < 75 && starty - event.offsetY < 75) && (startx - event.offsetX > -75 && starty - event.offsetY > -75)){
    createAlert('info', 'If you drag the receipt further, it will become a popup')
  } else {
    createAlert('info', 'Receipt has been dragged, creating popup')
    receiptModal.style.display = 'none'
    offset = 0
    previframe.forEach(frame=>{
      options = `width=700, height=800, x=${25+offset}, y=${25+offset}
      alwaysOnTop=true,`
      console.log('opening with options', options)
      newwin = window.open(frame.src, '', options)
      windowlist.push(newwin)
      offset += 5
    })
    if(windowlist.length > 0){
      windowlist[0].focus()
    }
  }
})
document.getElementById('viewer').addEventListener('click', event=>{
  createAlert('info', 'Receipt has been clicked, creating popup')
  $(receiptModal).hide()
  offset = 0
  previframe.forEach(frame=>{
    options = `width=700, height=800, x=${25+offset}, y=${25+offset}
    alwaysOnTop=true,`
    console.log('opening with options', options)
    newwin = window.open(frame.src, '', options)
    windowlist.push(newwin)
    offset += 5
  })
  if(windowlist.length > 0){
    windowlist[0].focus()
  }
})
document.getElementById('near_close').addEventListener('click', event=>{
  createAlert('info', 'Receipt has been clicked, creating popup')
  $(receiptModal).hide()
  offset = 0
  previframe.forEach(frame=>{
    options = `width=700, height=800, x=${25+offset}, y=${25+offset}
    alwaysOnTop=true,`
    console.log('opening with options', options)
    newwin = window.open(frame.src, '', options)
    windowlist.push(newwin)
    offset += 5
  })
  if(windowlist.length > 0){
    windowlist[0].focus()
  }
})


async function dispReceiptModal(file_id){
  previframe.forEach(frame=>{
    viewerEle.removeChild(frame)
  })
  previframe = []
  windowlist.forEach(win=>{
    win.close()
  })
  windowlist = []
  viewerEle.innerHTML = '';

  createAlert('info', 'Loading File')
  arg = {
    filesys_id:file_id
  }

  ipcRenderer.invoke('load-file-filesys', arg).then(async result=>{
    loaded_file = result.recordset[0]
    console.log('loaded file', loaded_file)
    $(receiptModal).show();
    viewerEle.innerHTML = '';
    const iframe = document.createElement('iframe')

    // OPENING PDF CODE
    pdfData = base64ToUint8Array(loaded_file.filesys_content);
    targeturl = createObjectURL(new Blob([pdfData], {type: "pdf"}))

    // SHARED CODE
    let viewerUrl = '../pdfjs/web/viewer.html?file=' + encodeURIComponent(targeturl);

    iframe.src = viewerUrl
    viewerEle.appendChild(iframe);
    previframe.push(iframe)
  }).catch(err=>{
    createAlert('error', 'File could not be Loaded: ' +String(err))
  })
}

document.getElementById("modifyselected").addEventListener('click', async()=>{
  event.preventDefault()
  
  let target = selection.value
  if (!target || target == '') {
    createAlert('no selection to load')
  } else {
    console.log("loading", target)
    $(goto_back).show()
    await requestEntry(target)
  }
})

document.getElementById("createnew").addEventListener('click', ()=>{
  event.preventDefault()
  goto_add.click()
  $(goto_add).show()
  $(goto_delete).show()
  $(goto_transfer).show()

})

document.getElementById("denyrequest").addEventListener('click', ()=>{
  event.preventDefault()
  if(notes.value ==""){
    createAlert("Info","please give a reason for denial")

  }else{
    if(stagenum == 0){
      if(confirm("Are you sure you want to delete request")){
        submitsupervisorform(false)
      }
    }else{
      if(confirm("Are you sure you want to Cancel/Deny request")){
        submitsupervisorform(false)
      }
    }
  }

  //   if(confirm("Are you sure you want to Cancel/Deny request")){
  //     submitsupervisorform(false)
  //   }
  // }
})


document.getElementById("approverequest").addEventListener('click', ()=>{
  event.preventDefault()
  submitsupervisorform(true)

})



function submitsupervisorform(approve){
  if(stagenum >= 1){//check
    arg={
      FemaRate:document.getElementById("femarate").value,
      FemaCode:document.getElementById("femacode").value,
      log_note:document.getElementById("notes").value,
      Equipmentformid:selection.value
    }

  }else{
    arg={
      log_note:document.getElementById("notes").value,
      Equipmentformid:selection.value
    }

  }


  if(approve){
    arg.Status = mode_list[stagenum+1]

    console.log(arg)

    ipcRenderer.invoke('modify-selected-equipment-recap',arg).then(async result =>{
      console.log('Status', result)
      createAlert("success","Submitted Sucessfully")
      goto_list.click()
    }).catch(error => {
      console.log("submiterror",error)
      createAlert("error","Failed to submit")
    })
  }else{

    arg.Status = mode_list[stagenum-1]
    if(arg.Status==null){
      arg.Status="CANCELLED"
    }
    console.log(arg)

    ipcRenderer.invoke('modify-selected-equipment-recap',arg).then(async result =>{
      console.log('Status', result)
      createAlert("success","Denied")
      goto_list.click()

    }).catch(error => {
      console.log("submiterror",error)
      createAlert("error","Failed to submit")
    })
  }

}


document.getElementById('upload_documentation_button').addEventListener('click', ()=>{
    event.preventDefault()
    // console.log('upload_documentation_button')
    $(documentationModal).show();
})

document.getElementById('close_documentationModal').addEventListener('click', ()=>{
  event.preventDefault()
  $(documentationModal).hide()
})

async function parseAndSetModifyequipment(arg) {

  document.getElementById('datanumber').value= arg.Data_NO
  document.getElementById('equipmentclassifications').value= arg.Description
  document.getElementById('purchasedate').valueAsDate= arg.purchase_Date
  document.getElementById('equipmentmanufacturers').value= arg.Manufacturer
  document.getElementById('othervendorInput').value= arg.Vendor
  document.getElementById('otherInput').value= arg.Manufacturer
  document.getElementById('equipmentvendors').value= arg.Vendor
  equipmentvendors=document.getElementById("equipmentvendors").value 
  document.getElementById('model').value= arg.Model
  document.getElementById('year').value= arg.Year
  document.getElementById('inservicedate').value= arg.InService
  document.getElementById('serialnumber').value= arg.serial_number
  document.getElementById('attachedequipid').value= arg.Attached_equipID
  // document.getElementById('equipmentvendors').value= arg.Vendor
  document.getElementById('equipmentlocations').value= arg.Location
  document.getElementById('departments').value= arg.Department
  document.getElementById('newdepartment').value= arg.Department_New
  document.getElementById('newlocation').value= arg.Location_New
  document.getElementById('femacode').value= arg.FemaCode
  document.getElementById('femarate').value= arg.FemaRate
  document.getElementById('avlserialnumber').value= arg.AVLSerial
  Modify_Type= arg.Modify_Type
  // if ()

  if(document.getElementById('equipmentvendors').value != arg.Vendor){
    $(othervendorInput).show()

    document.getElementById('equipmentvendors').value= "Other"
  }
  
  if(document.getElementById('equipmentmanufacturers').value != arg.Manufacturer){
    $(otherInput).show()

    document.getElementById('equipmentmanufacturers').value= "Other"
  }

  // if( Modify_Type == 'DEL' || Modify_Type == 'TRA' && stagenum == 0){
  //   $('#Add').find('*').prop('disabled', true)
  //   $('#notes').prop('disabled', false)
  //   $('#addsubmit').prop('disabled', false)
  //   $('#documentlist').prop('disabled', false)
  //   $('#upload_documentation_button').prop('disabled', false)

   
  // }else{
  //   $('#Add').find('*').prop('disabled', false)
  //   $('approverequest').prop('disabled', false)
  // }  

  // }else if(Modify_Type == 'TRA' && stagenum == 0){
  //   $('#Add').find('*').prop('disabled', true)
  //   $('#notes').prop('disabled', false)
  //   $('#addsubmit').prop('disabled', false)
  //   $('#documentlist').prop('disabled', false)
  //   $('#upload_documentation_button').prop('disabled', false)
    
  // }
  

  

  document.getElementById('Formid').value= arg.Modify_Type + "00" +arg.Formid
  parseAndSet
  if (Modify_Type == 'ADD'){
    $(Movedepartment).hide()
    $(Movelocation).hide()
    //$(avlserial).show()
    
    

  }else if (Modify_Type == 'DEL'){
    $(Movedepartment).hide()
    $(Movelocation).hide()
    //$(avlserial).show()
    

  }else{
    $(Movedepartment).show()
    $(Movelocation).show()
    //$(avlserial).show()
  }

  

  // reset list
  for (let i = lognotelist.length - 1; i >= 0; i--){
    lognotelist.remove(i);
  }

  if (arg.log_notes && arg.log_notes.length > 0) {
    $(lognotelistheader).show();
    $(lognotelist).show();

    lognotelist.size = String(Math.min(Math.max(arg.log_notes.length, 2), 4))

    arg.log_notes.forEach(log =>{
      let d1 = new Date(log.log_time)
      let name = (log.log_uname)+
      ', ' + d1.toUTCString().substring(5, 16)+
      ': ' + (log.log_note)

      option = document.createElement('option')
      option.value = ''
      option.text = name
      lognotelist.prepend(option)
    });
  } else {
    $(lognotelist).hide()
    $(lognotelistheader).hide()
  }
}

async function parseAndSet(arg) {

  document.getElementById('datanumber').value= arg.ID
  document.getElementById('equipmentclassifications').value= arg.Classification
  document.getElementById('purchasedate').valueAsDate= arg.PurchaseDate
  document.getElementById('equipmentmanufacturers').value= arg.Manufacturer
  document.getElementById('model').value= arg.Model
  document.getElementById('year').value= arg.Year1
  document.getElementById('inservicedate').value= arg.InService
  document.getElementById('serialnumber').value= arg.SerialVINNumber
  document.getElementById('attachedequipid').value= arg.AttachEquipDataID
  document.getElementById('equipmentvendors').value= arg.Vendor
  document.getElementById('equipmentlocations').value= arg.Location
  document.getElementById('departments').value= arg.Department
  document.getElementById('avlserialnumber').value= arg.AVLSerial
  }
  





document.getElementById('lookupsubmit').addEventListener('click', async ()=>{
  event.preventDefault()
  console.log('asdf')
  if (document.getElementById("datanumber2").checkValidity()){
    arg= {
      datanumber2:document.getElementById("datanumber2").value
    }
    await ipcRenderer.invoke('deletelookup', arg).then(async result=>{
      console.log('result', result)
      if(result && result.recordset && result.recordset.length > 0){
        arg = result.recordset[0]

         if (Modify_Type== "DEL"){
          swapPage('Add', goto_delete, 'navy')
         }else{
          swapPage('Add', goto_transfer, 'darkred')
         }
        parseAndSet(arg)
      } else {
        createAlert('info', 'No Inventory Item with that ID')
      }
    }).catch(err=>{
      createAlert('error', 'Data could not be Loaded: ' +String(err))
    })
  } else {
    datanumber2.reportValidity()
  }
})

const lognotelist = document.getElementById("lognotelist")
const lognotelistheader = document.getElementById("lognotelistheader")




documentlist = document.getElementById('documentlist')
documentlist_mirror = document.getElementById('documentlist_mirror')
uploadfilelist=[]

const upload_event_docs = document.getElementById('documentation_fileselect_popup')
upload_event_docs.addEventListener('click', async (event)=>{
  event.preventDefault()
  if (document.getElementById('documentation_type').checkValidity()){
    let path = await ipcRenderer.invoke('open-file-dialog-pdf')

    if (path.canceled){
      console.log('selection canceled')
    } else {

      arg = {
        path:String(path.filePaths[0]),
        filesys_linked_table:'modifyequipment',
        //filesys_linked_id:document.getElementById('Modify_Type').value + document.getElementById('Data_NO').value,
        filesys_name:document.getElementById('documentation_type').value +'.pdf'
      }
      console.log('arg', arg)

      createAlert('info', 'Uploading File')
      await ipcRenderer.invoke('save-file-to-filesys', arg).then(async result =>{
        createAlert('success', 'File Uploaded!')
        console.log('saved file to', result.recordset[0].filesys_id)
        uploadfilelist.push(result.recordset[0].filesys_id)
        
        
        loadDocumentsByIdList(uploadfilelist)
      }).catch(err =>{
        createAlert('error', 'Upload Failed: '+err.toString())
      })
    }
  } else {
    document.getElementById('documentation_type').reportValidity()
  }
})

documentlist_mirror.addEventListener('change', event =>{
  console.log('documentlist clicked', documentlist_mirror.value)
  dispReceiptModal(documentlist_mirror.value)
  documentlist_mirror.value = ''
})

documentlist.addEventListener('change', event =>{
  console.log('documentlist clicked', documentlist.value)
  dispReceiptModal(documentlist.value)
  documentlist.value = ''
})


let documentationModal = document.getElementById("documentationModal");
document.getElementsByClassName("close")[1].onclick = function() {
  $(documentationModal).hide()
}
let receiptModal = document.getElementById('receiptModal')
document.getElementsByClassName("close")[0].onclick = function() {
  $(receiptModal).hide()
}

window.onclick = function(event) {
  if (event.target == receiptModal) {
    $(receiptModal).hide()
  } else if (event.target == documentationModal) {
    $(documentationModal).hide()
  }
}

async function requestEntry(id){
  console.log('REQUEST ENTRY !!!!!!!!!!!!!!!!!!!!!!!!!!!', id)
  // console.log('request todo-selection')

  arg = {
    target_name: 'Equipmentformid',
    target_val: id
  }

  return ipcRenderer.invoke('loadequipmentlist', arg).then(result =>{
    console.log(result)
    if (result && result.recordset && result.recordset[0]) {
      arg4 = result.recordset[0]
      console.log('loaded', arg4)
      swapPage('Add', goto_selection, 'darkred')
      goto_list.removeAttribute('disabled')
      loadDocumentsByIdList(JSON.parse(arg4.Linked_File))
      parseAndSetModifyequipment(arg4)
    } else {
      if (selection && selection.value && selection.value != ''){
        createAlert('warning', "Unable to load selection; someone else may have just completed it. Refreshing options list.")
        // requestList()
      } else {
        createAlert('warning', "No RECAP selected. Please select a RECAP from the list and try again.")
      }
    }
    return arg4
  })
  // .catch(err =>{
  //   createAlert('warning', 'ERROR: Lookup Failed Due to Invalid Request Parameters: '+err.toString())
  // })
}

document.getElementById('pdf_selected').addEventListener('click', async event=>{
  event.preventDefault()
  let target = selection.value

  if (!target || target == '') {
    createAlert('no selection to load')
  } else {
    console.log('loading', target)
    // await requestEntry(target)
    await viewTravelReport(2, target)
  }
})

// FIXME: FIXED: this function was missing
async function loadAllFileContents(file_list){
  filesysarg = {
    filesys_linked_table:'modifyequipment',
    filesys_id_list:file_list
  }

  console.log('loading list', file_list)
  return await ipcRenderer.invoke('loadAllFileContents', filesysarg)
}

async function viewTravelReport(mode=0, id, indata=null){
  console.log('REQUEST REPORT !!!!!!!!!!!!!!!!!!!!!!!!!!!')
  arg = {
    target_name: 'Equipmentformid',
    target_val: selection.value
  }

  try{
    if (!indata){
      console.log('load data')
      result = await ipcRenderer.invoke('loadequipmentlist', arg)
      arg = result.recordset[0]
    } else {
      console.log('imported data')
      arg = indata
    }

    if (arg && id){
      console.log('REPORT DATA LOADED', arg)
      try{
        receiptModal.style.display = "block";
        previframe.forEach(frame=>{
          try{
            viewerEle.removeChild(frame)
          } catch{
            console.log('malformed frame', frame, 'could not be removed')
          }
        })
        previframe = []
        windowlist.forEach(win=>{
          win.close()
        })
        windowlist = []

        viewerEle.innerHTML = '';
      } catch (err){
        createAlert('PDF ERROR'+err.toString())
      }

      if (mode == 1){
        try {
          // FIXME: FIXED: JSON PARSE ERROR: this was incorrectly linking to 'arg.travel_linked_filesys_ids', which is the name of the attribute in the 'travel request' app
          file_list = JSON.parse(arg.Linked_File)
          // FIXME: FIXED: made it prettier if there are no files to load
          if (file_list.length > 0){
            createAlert('info', 'Loading Receipts to Merge')
            await loadAllFileContents(file_list).then(file_results=>{
              file_results.recordset.forEach(loaded_file=>{
                pdfData = base64ToUint8Array(loaded_file.filesys_content);
                subfileurl = createObjectURL(new Blob([pdfData], {type: "pdf"}))
                const iframe = document.createElement('iframe')
                let viewerUrl = '../pdfjs/web/viewer.html?file=' + encodeURIComponent(subfileurl);
                iframe.src = viewerUrl
                viewerEle.appendChild(iframe);
                previframe.push(iframe)
              })
              
            }).catch(err=>{
              createAlert('error', 'Receipts Could not be Loaded ' +String(err))
             
            })
          } else {
            console.log('No reciepts to display!')
           
          }
        } catch (err) {
          createAlert('info', 'Report Could not be Displayed! ' +String(err))
         
        }
      } else if (mode == 2){
        try {
          targeturl = await makeEquipmentPDF(arg)

          const iframe = document.createElement('iframe')
          let viewerUrl = '../pdfjs/web/viewer.html?file=' + encodeURIComponent(targeturl);

          iframe.src = viewerUrl
          viewerEle.appendChild(iframe);
          previframe.push(iframe)
        } catch (err) {
          createAlert('info', 'Report Could not be Displayed! ' +String(err))
        }
        try {
          file_list = JSON.parse(arg.Linked_File)
          if (file_list.length > 0){
            createAlert('info', 'Loading Receipts to Merge')
            await loadAllFileContents(file_list).then(file_results=>{
              file_results.recordset.forEach(loaded_file=>{
                pdfData = base64ToUint8Array(loaded_file.filesys_content);
                subfileurl = createObjectURL(new Blob([pdfData], {type: "pdf"}))
                const iframe = document.createElement('iframe')
                let viewerUrl = '../pdfjs/web/viewer.html?file=' + encodeURIComponent(subfileurl);
                iframe.src = viewerUrl
                viewerEle.appendChild(iframe);
                previframe.push(iframe)
              })
              console.log(arg)
            }).catch(err=>{
              createAlert('error', 'Receipts Could not be Loaded')
              console.log(arg)
            })
          
          } else {
            console.log('No reciepts to display!')
          
          }
        } catch (err) {
          createAlert('info', 'Report Could not be Displayed! ' +String(err))
          
        }
      } else {
        try {
          targeturl = await makeEquipmentPDF(arg)

          const iframe = document.createElement('iframe')
          let viewerUrl = '../pdfjs/web/viewer.html?file=' + encodeURIComponent(targeturl);

          iframe.src = viewerUrl
          viewerEle.appendChild(iframe);
          previframe.push(iframe)
        } catch (err) {
          createAlert('info', 'Report Could not be Displayed! ' +String(err))
        }
      }
    } else {
      if (id && id != ''){
        createAlert('warning', "Unable to load report for id " +String(id) +"; Something must have gone wrong. Refreshing options list.")
        requestList()
      } else {
        createAlert('warning', "Report ID to load not specified. Report Load Cancelled")
      }
    }
  } catch (err) {
    createAlert('warning', 'ERROR: Lookup Failed Due to Invalid Request Parameters: '+err.toString())
  }
  return arg
}



let curstage = null

const goto_back = document.getElementById('goto_back')
const goto_home = document.getElementById('goto_home')

window.onbeforeunload = function(){
  windowlist.forEach(win=>{
    win.close()
  })
  windowlist = []
  viewerEle.innerHTML = '';
};

goto_back.addEventListener('click', ()=>{
  // event.preventDefault()
  console.log('go back to prev stage')
  if (curstage == goto_add || goto_delete || goto_transfer ){
    
    goto_list.click()
  

  } 
})
goto_list.click()
