
const selection = {}

function makeSelectable(){
  let trs = document.querySelectorAll("tr");
  for(let i = 0; i < trs.length; i++){
    console.log('table row class:', trs[i].className)
    if (trs[i].className.includes('multiselect')){
      trs[i].addEventListener("mouseup", function(){
        // console.log('selection set')
        let cn = this.className, thc = " selected", start_idx = cn.indexOf(thc);
        if(start_idx == -1) cn += thc;
        else cn = cn.replace(thc,"");
        this.className = cn;
        selection.value = this.cells[0].textContent
        console.log('selection set', selection.value)
      })
    } else if (trs[i].className.includes('singleselect')){
      trs[i].addEventListener("mouseup", function(){
        // console.log('selection set')
        for(let i = 0; i < trs.length; i++){
          let cn = trs[i].className, thc = " selected", start_idx = cn.indexOf(thc);
          if(start_idx != -1 && trs[i].className.includes('singleselect')) {
            cn = cn.replace(thc,"");
            trs[i].className = cn;
          }
        }
        let cn = this.className, thc = " selected", start_idx = cn.indexOf(thc);
        if(start_idx == -1) cn += thc;
        this.className = cn;
        selection.value = this.cells[0].textContent
        console.log('selection set', selection.value)
      })
    }
  }
}

module.exports = {selection, makeSelectable}