async function increment(num) {
    return num + 1;
  }

  // Even though you returned a number, the value is
  // automatically wrapped in a promise, so we call
  // `then` on it to access the returned value.
  //
  // Logs: 4
  increment(3).then(num => console.log(num));

describe('async then test', function() {
    it('should log promises first, then result', async function() {
        const result = increment(12)
        console.log('.then promise', result)
        result.then(outval =>{
            console.log('.then done', outval)
        })
    })
})

describe('async await test', function() {
    it('implicit wait and direct result return', async function() {
        const result = await increment(12)
        console.log('await done', result)
    })
})