const username = require('username');
const should = require('chai').should();
const db = require('../db')

let uname = ''
username().then(result =>{
  uname = result
  console.log('username:', uname)
}).catch(err =>{
  console.log('username error:', err.name)
  console.log(err)
})

const arg = {
  'event_type':'Training',
  'event_regis_fee':500,
  'event_regis_date':new Date(),
  'event_start_date':new Date(),
  'event_end_date':new Date(),
  'event_name':'Guys training',
  'event_desc':'guy teaches class',
  'event_provider':'Guy Industries',
  'event_street':'23 Finker St',
  'event_city':'Chust',
  'event_state':'SC',
  'event_zip_code':'12345',
  'event_bfst_prov':3,
  'event_lnch_prov':2,
  'event_dinn_prov':1,
  'e_doc_path':'',
  'travel_method':'Commercial Air',
  'travel_dist_miles':123,
  'travel_airfare_estimate':123,
  'travel_has_rental_car':1,
  'travel_desc':'travel description',
  'travel_depart_datetime':new Date(),
  'travel_return_datetime':new Date(),
  'travelers':[100012, 100013],
  'travel_personal_days':1,
  'travel_eligible_lodging_nights':2,
  'travel_eligible_rental_car_days':3,
  'travel_max_reinbursible':4,
  'travel_bfst_allowed':5,
  'travel_lnch_allowed':6,
  'travel_dinn_allowed':7,
  'travel_bfst_not_cvrd':8,
  'travel_lnch_not_cvrd':9,
  'travel_dinn_not_cvrd':0,
  'travel_form_status':'New Travel'
}

describe('DB create event test', function() {
  describe('insert event by arg', function() {
    it('should return event id', async function() {
      result = await db.createEvent(arg, uname)
      should.exist(result[0])
    });
  });
});