const {ipcRenderer} = require('electron')
const {createObjectURL} = require('blob-util')
const $ = require('jquery')
const {makeEquipmentPDF} = require('../utilities/reportgen')
let windowlist = []
let previframe = []

const {createAlert} = require("../utilities/alert_box")

document.getElementById("quit_app").addEventListener("click", ()=>{
  ipcRenderer.invoke('quit_app')
});

mode_list=["DENIED","NEW FORM","APPROVED FORM","COMPLETED"]
// CLOSE ALL POPUPS ON PAGE CHANGE
window.onbeforeunload = function(){
    windowlist.forEach(win=>{
      win.close()
    })
    windowlist = []
    viewerEle.innerHTML = '';
  };
  
  // dynamic html stuff:
  let values = window.location.search.split('?')
  console.log('vals', values)
  let stagenum = 0
  
  if (values.length >= 1 && values[1] && parseInt(values[1])){
    stagenum = parseInt(values[1])
  }
  console.log("stagenum",stagenum)

  
  // Major Button Logic
let goto_submitrequest= document.getElementById("goto_submitrequest")
goto_submitrequest.addEventListener('click', () => {
  ResetAll()
    
  if(stagenum == 0){

    $('#goto_back').show()
    $(approvedenyrequest).hide()
    $('#goto_selection').hide()
    $(lognotelist).hide()
    $(lognotelistheader).hide()
    $('#goto_list').hide()


  }

  swapPage('submitrequest', goto_submitrequest, 'forestgreen') 
    

    /*$('#goto_back').show()
    
    $(formno).hide()
    $(avlserial).hide()
    $(Movedepartment).hide()
    $(Movelocation).hide()
    $(femac).hide()
    $(femar).hide()
    
   
    $(approvedenyrequest).hide()
    Modify_Type= 'ADD'
    
    // document.getElementById("purchasedate").setAttribute("required","required")
    $('#Add').find('*').prop('disabled', false)
    $('#addsubmit').show()
    $('#goto_selection').hide()
    $(lognotelist).hide()
    $(lognotelistheader).hide()
    uploadfilelist=[]*/




    ResetAll()

})

departments= ipcRenderer.invoke('getdepartments').then(result => {
  departments = result
  console.log("departments",departments)
  for (let i = 0; i < departments.length; i++) {
    let name = departments[i].Department
    let id = departments[i].Department
    option = document.createElement('option')
    option.value = id
    option.text = name
    document.getElementById("departments").add(option)
    option = document.createElement('option')
    
    
  }
})

crew= ipcRenderer.invoke('getcrew').then(result => {
  crew = result
  console.log("crew",crew)
  for (let i = 0; i < crew.length; i++) {
    let name = crew[i].CrewNames
    let id = crew[i].CrewNames
    option = document.createElement('option')
    option.value = id
    option.text = name
    document.getElementById("crew").add(option)
    option = document.createElement('option')
    
    
  }
})

equipmentlocations = ipcRenderer.invoke('getequipmentlocations').then(result => {
  equipmentlocations = result
  console.log("equipmentlocations",equipmentlocations)
  for (let i = 0; i < equipmentlocations.length; i++) {
    let name = equipmentlocations[i].LocationID
    let id = equipmentlocations[i].LocationID
    option = document.createElement('option')
    option.value = id
    option.text = name
    document.getElementById("equipmentlocations").add(option)
    option = document.createElement('option')
    
  }
})

subitem_employeename = ipcRenderer.invoke('getemployeename').then(result => {
  subitem_employeename = result
  console.log("subitem_employeename",subitem_employeename)
  for (let i = 0; i < subitem_employeename.length; i++) {
    let name = subitem_employeename[i].FirstName + " " +subitem_employeename[i].LastName + " - " +subitem_employeename[i].ID
    let id = subitem_employeename[i].FirstName + " " +subitem_employeename[i].LastName + " - " +subitem_employeename[i].ID
    option = document.createElement('option')
    option.value = id
    option.text = name
    document.getElementById("subitem_employeename").add(option)
    option = document.createElement('option')
    
  }
})

subitem_materialdescription = ipcRenderer.invoke('getmaterialdescription').then(result => {
  subitem_materialdescription = result
  console.log("subitem_materialdescription",subitem_materialdescription)
  for (let i = 0; i < subitem_materialdescription.length; i++) {
    let name = subitem_materialdescription[i].Description1 + "- " +subitem_materialdescription[i].ID
    let id = subitem_materialdescription[i].Description1 + "- " +subitem_materialdescription[i].ID
    option = document.createElement('option')
    option.value = id
    option.text = name
    document.getElementById("subitem_materialdescription").add(option)
    option = document.createElement('option')
    
  }
})

async function SubitemAction(mode = ''){
  console.log('mode', mode)

  
  if (mode == 'remove') {
    if (subitemselection && subitemselection.value && subitemselection.value.subitem_id && subitemselection.value.subitem_id != null && subitemselection.value.subitem_id != '') {
      console.log('delete subitemselection', subitemselection.value)
      ipcRenderer.invoke('delete-pcard-recap-subitem', subitemselection.value).then(async ()=>{
        refreshSubitemList(document.getElementById('Formid').value)
        document.getElementById('subitem_employeename').value = ''
        document.getElementById('subitem_materialdescription').value = ''
        document.getElementById('subitem_quantity').value = ''
        document.getElementById('subitem_fortask').value = ''
        subitemselection.value = null
      }).catch(async err=>{
        createAlert('warning', 'Subitem could not be deleted')
        console.log(err)
        remain = await refreshSubitemList(document.getElementById('Formid').value)
        document.getElementById('subitem_employeename').value = ''
        document.getElementById('subitem_materialdescription').value = ''
        document.getElementById('subitem_quantity').value = ''
        document.getElementById('subitem_fortask').value = ''
        subitemselection.value = null
      })
    } else {
      createAlert('warning', 'Please select an item in the list to ' +String(mode))
    }
  } else if (mode == 'add') {
    event.preventDefault()
    console.log('changes to be applied')

    arg = {
      subitem_id:document.getElementById('subitem_id').value,
      subitem_employeename:document.getElementById('subitem_employeename').value,
      subitem_materialdescription:document.getElementById('subitem_materialdescription').value,
      subitem_quantity:document.getElementById('subitem_quantity').value,
      subitem_fortask:document.getElementById('subitem_fortask').value, 
      subitem_Formid:document.getElementById('Formid').value
    }

    console.log('arg', arg)

    /*if ( arg.subitem_org_key != '' && arg.subitem_obj_code != '') {
      console.log('submit subitem query')
      ipcRenderer.invoke('update-pcard-recap-subitem', arg).then(async result =>{
        console.log('done', result)
        remain = await refreshSubitemList(arg.Subitem_Materialform_ID)
        document.getElementById('Subitem_laborid').value = ''
        document.getElementById('Subitem_laborname').value = ''
        document.getElementById('subitem_obj_code').value = ''
      }).catch(err =>{
        createAlert('warning', 'Subitem Query Failed')
        console.log(err)
        refreshSubitemList(arg.subitem_txn_id)
      })
    } else {
      if (arg.subitem_org_key == ''){
        createAlert('danger', 'Cannot add Subitem with $ Amt of 0.00')
        document.getElementById('subitem_total').focus()
      } else if (arg.subitem_org_key == ''){
        createAlert('danger', 'Cannot add Subitem without Org Key Selected')
        document.getElementById('subitem_org_key').focus()
      } else if (arg.subitem_obj_code == ''){
        createAlert('danger', 'Cannot add Subitem without Obj Code Selected')
        document.getElementById('subitem_obj_code').focus()
      }
    }*/
  }
}

document.getElementById('itemlist_add').addEventListener('click', ()=>{
  event.preventDefault()
  SubitemAction('add')
})



document.getElementById('itemlist_remove').addEventListener('click', ()=>{
  event.preventDefault()
  SubitemAction('remove')
})

const selection = {}
const subitemselection = {}
function makeRecaplistSelectable(){
  let trs = document.querySelectorAll("tr");
  for(let i = 0; i < trs.length; i++){
    // console.log('table row class:', trs[i].className)
    if (trs[i].className.includes('singleselect')){
      trs[i].addEventListener("mouseup", function(){
        // console.log('selection set')
        for(let i = 0; i < trs.length; i++){
          let cn = trs[i].className, thc = " selected", start_idx = cn.indexOf(thc);
          if(start_idx != -1 && trs[i].className.includes('singleselect')) {
            cn = cn.replace(thc,"");
            trs[i].className = cn;
          }
        }
        let cn = this.className, thc = " selected", start_idx = cn.indexOf(thc);
        if(start_idx == -1) cn += thc;
        this.className = cn;
        selection.value = JSON.parse(this.cells[0].textContent).Equipmentformid

        console.log('selection set', selection.value)
        // getExtraUserData(JSON.parse(this.cells[0].textContent))
      })
    }
  }
}


const table = document.getElementById('recaplist')
let goto_list = document.getElementById("goto_list")
goto_list.addEventListener('click', () => {
  ResetAll()
  if (stagenum == 1){
    $('#goto_list').show()


    $('#goto_submitrequest').hide()
  }

}) 



function swapPage(pageName, elmnt, color){

    const tabcontent = document.getElementsByClassName("tabcontent")
    for (i=0; i < tabcontent.length; i++) {
    $(tabcontent[i]).hide()
    }

    const tablinks = document.getElementsByClassName("tablink")
    for (i=0; i < tablinks.length; i++) {
    tablinks[i].style.backgroundColor = ""
    tablinks[i].style.backgroundImage = ""
    }

    let targetpage = document.getElementById(pageName)
    $(targetpage).show()
    targetpage.style.backgroundColor = color
    elmnt.style.backgroundColor = color;
    elmnt.style.backgroundImage = 'none'
}





/*document.getElementById('remove_filter').addEventListener('click', ()=>{
  event.preventDefault()
  console.log('remove filter', subitemselection.value)

  if (subitemselection.value && subitemselection.value.value != ''){
    console.log('selection set!')
    document.querySelectorAll(".selected").forEach(selected_row=>{
      selected_row.remove()
    })
    filter_type.value = ''
    filter_value.value = ''
    subitemselection.value = ''
  } else {
    createAlert('warning', 'Nothing selected to Delete')
  }
})

document.getElementById('reset_filter').addEventListener('click', ()=>{
  event.preventDefault()
  console.log('reset_filter')
  document.getElementById('filteritemlist').querySelectorAll("tr").forEach(row=>{
    row.remove()
  })
  subitemselection.value = null
  filter_pcard_cardnum.blur()
  document.getElementById('filter_type').value = ''

  let filter_value = document.getElementById('filter_value')
  filter_value.value = ''
  filter_value.type = 'text'
  filter_value.pattern = null //pattern null always fails
  filter_value.removeAttribute('list')
  filter_value.title = 'Select a Filter Type'
})*/


function ResetAll(){

  document.getElementById("departments").value=""
  document.getElementById("crew").value=""
}



goto_submitrequest.click()
goto_list.click()