// https://www.pdftron.com/blog/electron/how-to-build-an-electron-pdf-viewer/

const { ipcRenderer } = require('electron');
const path = require('path');

// Add an event listener to our button.
document.getElementById('myButton').addEventListener('click', async ()=>{

    filePaths = await ipcRenderer.invoke('open-file-dialog-pdf')
    console.log('You selected:', filePaths)

    if (filePaths.canceled){
      console.log('selection canceled')
    } else {
      console.log('path selected', filePath = filePaths.filePaths[0])

        console.log('filePath', filePath)

        const viewerEle = document.getElementById('viewer');
        viewerEle.innerHTML = ''; // destroy the old instance of PDF.js (if it exists)

        // Create an iframe that points to our PDF.js viewer, and tell PDF.js to open the file that was selected from the file picker.
        const iframe = document.createElement('iframe');
        iframe.src = path.resolve(__dirname, `../pdfjs/web/viewer.html?file=${filePath}`);

        // Add the iframe to our UI.
        viewerEle.appendChild(iframe);
    }
})